﻿
namespace Grayscale.P211_WordShogi__.L250____Word
{


    /// <summary>
    /// ************************************************************************************************************************
    /// 方角（移動方向）
    /// ************************************************************************************************************************
    /// </summary>
    public enum Hogaku
    {

        /// <summary>
        /// 上
        /// </summary>
        上,

        /// <summary>
        /// 右上
        /// </summary>
        昇,

        /// <summary>
        /// 右
        /// </summary>
        射,

        /// <summary>
        /// 右下
        /// </summary>
        沈,

        /// <summary>
        /// 下
        /// </summary>
        引,

        /// <summary>
        /// 左下
        /// </summary>
        降,

        /// <summary>
        /// 左
        /// </summary>
        滑,

        /// <summary>
        /// 左上
        /// </summary>
        浮,

        /// <summary>
        /// 右上へ桂馬飛び
        /// </summary>
        駆,

        /// <summary>
        /// 左上へ桂馬飛び
        /// </summary>
        跳,

        /// <summary>
        /// 右下へ桂馬飛び
        /// </summary>
        踏,

        /// <summary>
        /// 左下へ桂馬飛び
        /// </summary>
        退,

        /// <summary>
        /// 向きなし
        /// </summary>
        None
    }
}
