﻿using Grayscale.P213_Komasyurui_.L250____Word;

namespace Grayscale.P268_ConvWords__.L500____Converter
{
    public abstract class Conv_Komasyurui
    {
        /// <summary>
        /// ************************************************************************************************************************
        /// 駒の文字を、列挙型へ変換。
        /// ************************************************************************************************************************
        /// </summary>
        /// <param name="moji"></param>
        /// <returns></returns>
        public static string Syurui_ToStrIchimoji(Komasyurui14 ks14)
        {
            string syurui;

            switch (ks14)
            {
                case Komasyurui14.H01_Fu_____:
                    syurui = "歩";
                    break;

                case Komasyurui14.H02_Kyo____:
                    syurui = "香";
                    break;

                case Komasyurui14.H03_Kei____:
                    syurui = "桂";
                    break;

                case Komasyurui14.H04_Gin____:
                    syurui = "銀";
                    break;

                case Komasyurui14.H05_Kin____:
                    syurui = "金";
                    break;

                case Komasyurui14.H07_Hisya__:
                    syurui = "飛";
                    break;

                case Komasyurui14.H08_Kaku___:
                    syurui = "角";
                    break;

                case Komasyurui14.H06_Oh_____:
                    syurui = "玉";
                    break;

                case Komasyurui14.H11_Tokin__:
                    syurui = "と";
                    break;

                case Komasyurui14.H12_NariKyo:
                    syurui = "杏";
                    break;

                case Komasyurui14.H13_NariKei:
                    syurui = "圭";
                    break;

                case Komasyurui14.H14_NariGin:
                    syurui = "全";
                    break;

                case Komasyurui14.H09_Ryu____:
                    syurui = "竜";
                    break;

                case Komasyurui14.H10_Uma____:
                    syurui = "馬";
                    break;

                default:
                    syurui = "×";
                    break;
            }

            return syurui;
        }

    }
}
