﻿using Grayscale.P003_Log________.L500____Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P258_UtilSky258_.L500____UtilSky;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P322_KifuTree___.L250____Struct;
using Grayscale.P323_PnlTaikyoku.L___500_Struct;

namespace Grayscale.P323_PnlTaikyoku.L500____Struct
{
    public class Model_PnlTaikyokuImpl : Model_PnlTaikyoku
    {

        #region プロパティ

        /// <summary>
        /// ------------------------------------------------------------------------------------------------------------------------
        /// GUI用局面データ。
        /// ------------------------------------------------------------------------------------------------------------------------
        /// 
        /// 局面が進むごとに更新されていきます。
        /// 
        /// </summary>
        public SkyConst GuiSkyConst { get { return this.guiSky; } }
        public void SetGuiSky(SkyConst sky)
        {
            this.guiSky = sky;
        }
        private SkyConst guiSky;
        public int GuiTemezumi { get; set; }
        public Playerside GuiPside { get; set; }

        #endregion


        public KifuTree Kifu
        {
            get
            {
                return this.kifu;
            }
        }
        private KifuTree kifu;



        public Model_PnlTaikyokuImpl()
        {
            //
            // 駒なし
            //
            this.GuiTemezumi = 0;
            Playerside firstPside = Playerside.P1;
            this.GuiPside = firstPside;
            this.guiSky = Util_SkyWriter.New_Komabukuro(firstPside);// 描画モデル作成時
            this.kifu = new KifuTreeImpl(
                    new KifuNodeImpl(
                        Util_Sky258A.NULL_OBJECT_SASITE,
                        new KyokumenWrapper( SkyConst.NewInstance(
                            this.guiSky,
                            this.GuiTemezumi
                            ))
                    )
            );
            //this.kifu.SetProperty(Word_KifuTree.PropName_FirstPside, firstPside);
            this.kifu.AssertPside(this.kifu.CurNode, "Model_PnlTaikyokuImpl",OwataMinister.BY_GUI);
            this.Kifu.SetProperty(Word_KifuTree.PropName_Startpos, "9/9/9/9/9/9/9/9/9");
        }

        /// <summary>
        /// クローン？
        /// </summary>
        /// <param name="kifu"></param>
        public Model_PnlTaikyokuImpl(KifuTree kifu)
        {
            this.kifu = kifu;
            //this.Kifu.SetProperty(Word_KifuTree.PropName_Startpos, "9/9/9/9/9/9/9/9/9");
        }
    }
}
