﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P276_SeizaStartp.L500____Struct;
using Grayscale.P324_ShogiGuiBas.L___500_Struct;
using System.Runtime.CompilerServices;

namespace Grayscale.P355_KifuParserA.L___500_Parser
{
    public delegate void DELEGATE_ChangeSky_Im_Srv(
        ShogiGui_Base shogiGui_Base,
        StartposImporter startposImporter,
        KifuParserA_Genjo genjo,
        KwErrorHandler errH
    );

    public interface KifuParserA
    {

        DELEGATE_ChangeSky_Im_Srv Delegate_OnChangeSky_Im_Srv { get; set; }


        /// <summary>
        /// １ステップずつ実行します。
        /// </summary>
        /// <param name="inputLine"></param>
        /// <param name="kifu"></param>
        /// <param name="larabeLogger"></param>
        /// <returns></returns>
        string Execute_Step(
            ref KifuParserA_Result result,
            ShogiGui_Base obj_shogiGui_Base,
            KifuParserA_Genjo genjo,
            KwErrorHandler errH
            ,
            [CallerMemberName] string memberName = "",
            [CallerFilePath] string sourceFilePath = "",
            [CallerLineNumber] int sourceLineNumber = 0
            );

        /// <summary>
        /// 最初から最後まで実行します。（きふわらべCOMP用）
        /// </summary>
        /// <param name="inputLine"></param>
        /// <param name="kifu"></param>
        /// <param name="larabeLogger"></param>
        void Execute_All(
            ref KifuParserA_Result result,
            ShogiGui_Base obj_shogiGui_Base,
            KifuParserA_Genjo genjo,
            KwErrorHandler errH
            ,
            [CallerMemberName] string memberName = "",
            [CallerFilePath] string sourceFilePath = "",
            [CallerLineNumber] int sourceLineNumber = 0
            );



    }
}
