﻿using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P371_Tansaku____.L___500_Tansaku;

namespace Grayscale.P371_Tansaku____.L500____Struct
{
    /// <summary>
    /// 探索中に変化するデータです。
    /// </summary>
    public class Tansaku_GenjoImpl : Tansaku_Genjo
    {


        public Tansaku_Args Args { get { return this.args; } }
        private Tansaku_Args args;

        /// <summary>
        /// 読み開始手目済み
        /// </summary>
        public int YomikaisiTemezumi { get; set; }

        /// <summary>
        /// 読んでいるノード。（生成後にセット）このノードに、ツリーをぶら下げていきます。
        /// </summary>
        public KifuNode Node_yomiNext { get { return this.node_yomiNext; } }
        public void SetNode_yomiNext(KifuNode node) {
            this.node_yomiNext = node;
        }
        private KifuNode node_yomiNext;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="yomikaisiTemezumi">読み開始局面の手目済み</param>
        /// <param name="yomiArgs"></param>
        /// <param name="temezumi_yomiCur">読んでいる局面の手目済み</param>
        /// <param name="pside_teban"></param>
        public Tansaku_GenjoImpl(
            KifuNode node_yomiKaisi, Tansaku_Args yomiArgs)
        {
            this.node_yomiNext = node_yomiKaisi;
            this.args = yomiArgs;

            // 読み開始時の手番を記憶しておきます。
            this.YomikaisiTemezumi = node_yomiKaisi.Value.ToKyokumenConst.Temezumi;
        }

    }
}
