﻿using Grayscale.P214_Masu_______.L250____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P507_Atama______.L___250_KyHandanOrder;

namespace Grayscale.P500_Kokoro_____.L500____Kokoro
{

    /// <summary>
    /// 頭の隅に置いてある、手の流れ。その目標物など。
    /// </summary>
    public class TenonagareGenjoImpl : TenonagareGenjo
    {
        /// <summary>
        /// 判断オーダー名。
        /// </summary>
        public KyHandanOrderName HandanOrderName { get { return this.handanOrderName; } }
        private KyHandanOrderName handanOrderName;

        /// <summary>
        /// 評価計算の名前。
        /// </summary>
        public TenonagareName Name { get { return this.name; } }// set;
        private TenonagareName name;

        /// <summary>
        /// どの駒が
        /// </summary>
        public RO_Star Koma1 { get { return this.koma1; } }// set;
        private RO_Star koma1;

        /// <summary>
        /// どの駒が＜その２＞
        /// </summary>
        public RO_Star Koma2 { get { return this.koma2; } }
        private RO_Star koma2;

        /// <summary>
        /// どのマスを
        /// </summary>
        public Basho Masu { get { return this.masu; } }// set;
        private Basho masu;

        public TenonagareGenjoImpl(KyHandanOrderName handanOrderName, TenonagareName name, RO_Star koma1, RO_Star koma2, Basho masu)
        {
            this.handanOrderName = handanOrderName;
            this.name = name;
            this.koma1 = koma1;
            this.koma2 = koma2;
            this.masu = masu;
        }

    }
}
