﻿using Grayscale.P021_ConstShogi_.L250____Const;
using Grayscale.P031_ConvText___.L500____Converter;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P505_Atama_Unou_.L___250_Unou;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using System;
using System.Text;


namespace Grayscale.P505_Atama_Unou_.L510____UtilFvFormat
{
    public abstract class Util_FeatureVectorFormat
    {

        /// <summary>
        /// テキストを作ります。
        /// </summary>
        /// <param name="fv"></param>
        /// <returns></returns>
        public static string Format_Text(FeatureVector fv)
        {
            StringBuilder sb = new StringBuilder();

            //
            // コメント
            //
            sb.AppendLine("\"#紹介文\",");
            sb.AppendLine("\"#\",");
            sb.AppendLine("\"#ボナンザ６．０アレンジ式きふわらべ２駒関係\",");
            sb.AppendLine("\"#\",");
            sb.AppendLine("\"#ボナンザ６．０の３駒関係を土台に、きふわらべでは２駒関係に改造☆\",");
            sb.AppendLine("\"#ちょこちょこと　ボナンザ６．０とは異なる箇所、ボナンザ６．０をそのまま真似ている箇所があるので、\",");
            sb.AppendLine("\"#この説明文は　『ボナンザ６．０アレンジ式きふわらべ２駒関係』　についてであることに、注意が　ひつよう☆\",");
            sb.AppendLine("\"#\",");
            sb.AppendLine("\"#0～999の範囲に収まるよう、全体的な視点を持って点数を入れたい。これらの各点数マスをパラメーターと呼び、このファイルの内容はフィーチャー・ベクターと呼ぶ。\",");
            sb.AppendLine("\"#このファイルでは、行と列の２軸を使っているので、２駒関係という。世の中には、３駒関係や、４駒関係、はたまた　駒関係を使っていないコンピューター将棋ソフトがあるらしい。\",");

            //
            // 仕様バージョン
            //
            sb.AppendLine();
            sb.AppendLine("\"Version\",1.0,");

            //
            // 駒割
            //
            sb.AppendLine();
            sb.AppendLine("\"#KomaWari 駒割。例えば、自分の歩が１０枚、相手の歩が８枚なら、自分が１枚得、相手が１枚損なので、差は２枚。局面評価は ここの歩の価値×2 として足し算する。\",");//コメント行
            sb.AppendLine("\"#Komawari そのうち、自分の駒に　と金が１枚あると、自分の歩が９枚、相手の歩が８枚となり、歩の差は＋１枚。と金の差は＋１枚。\",");
            sb.AppendLine("\"#Komawari なお、駒割の点数は、実際には高い倍率（例えば３２倍ぐらい）を掛けて使われる。駒の位置をちょっと得するよりは、駒取った方が点数が高いようにする。\",");
            sb.AppendLine("\"#Komawari 玉の駒割は計算で求める。 歩×18 ＋ 香×4 ＋ 桂×4 ＋ 銀×4 ＋ 金×4 ＋ 飛×2 ＋ 角×2。王を取るのが一番良い手、ぐらいの意味だろうか。\",");

            sb.Append("\"Komawari\",\"(0)歩\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H01_Fu_____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(1)香\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H02_Kyo____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(2)桂\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H03_Kei____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(3)銀\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H04_Gin____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(4)金\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H05_Kin____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(5)玉\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H06_Oh_____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(6)飛\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H07_Hisya__]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(7)角\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H08_Kaku___]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(8)と金\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H11_Tokin__]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(9)成香\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H12_NariKyo]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(10)成桂\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H13_NariKei]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(11)成銀\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H14_NariGin]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(12)竜\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H09_Ryu____]);
            sb.AppendLine(",");

            sb.Append("\"Komawari\",\"(13)馬\",");
            sb.Append(fv.Komawari[(int)Komasyurui14.H10_Uma____]);
            sb.AppendLine(",");


            sb.AppendLine("\"#KK fv_KK.csvへ移行。\",");//コメント行
            ////
            //// KK
            ////
            //sb.AppendLine();
            //sb.AppendLine("\"#KK 行が自玉、列が敵玉\",");//コメント行
            //sb.Append("\"#\",\"#\",");//列見出し行
            //for (int k2 = 0; k2 < ConstShogi.BAN_SIZE; k2++)
            //{
            //    sb.Append("\"");
            //    sb.Append(FeatureVectorImpl.K_To_Label(k2));
            //    sb.Append("\",");
            //}
            //sb.AppendLine();
            //for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)//データ行
            //{
            //    sb.Append("\"KK\",\"");// 行見出し
            //    sb.Append(FeatureVectorImpl.K_To_Label(k1));
            //    sb.Append("\",");

            //    for (int k2 = 0; k2 < ConstShogi.BAN_SIZE; k2++)//データ列
            //    {
            //        sb.Append(fv.NikomaKankei_KK[k1,k2]);
            //        sb.Append(",");
            //    }

            //    sb.AppendLine();
            //}

            //
            // KP
            //
            sb.AppendLine("");
            sb.AppendLine("\"#KP 行が自玉、列が調査項目\",");//コメント行
            sb.Append("\"#\",\"#\",");//列見出し行
            for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
            {
                sb.Append("\"");
                sb.Append(FeatureVectorImpl.P_To_Label(p2));
                sb.Append("\",");
            }
            sb.AppendLine();
            for (int k1 = 0; k1 < ConstShogi.BAN_SIZE; k1++)//データ行
            {
                sb.Append("\"KP\",\"");// 行見出し
                sb.Append(FeatureVectorImpl.K_To_Label(k1));
                sb.Append("\",");

                for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)//データ列
                {
                    sb.Append(fv.NikomaKankei_KP[k1, p2]);
                    sb.Append(",");
                }

                sb.AppendLine();
            }

            //
            // PP
            //
            sb.AppendLine("");
            sb.AppendLine("\"#PP P1P2も、P2P1も同じなので表は半分で済むが、入れている\",");//コメント行
            sb.Append("\"#\",\"#\",");//列見出し行
            for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)
            {
                sb.Append("\"");
                sb.Append(FeatureVectorImpl.P_To_Label(p2));
                sb.Append("\",");
            }
            sb.AppendLine();
            for (int p1 = 0; p1 < FeatureVectorImpl.CHOSA_KOMOKU_P; p1++)//データ行
            {
                sb.Append("\"PP\",\"");// 行見出し
                sb.Append(FeatureVectorImpl.P_To_Label(p1));
                sb.Append("\",");

                for (int p2 = 0; p2 < FeatureVectorImpl.CHOSA_KOMOKU_P; p2++)//データ列
                {
                    sb.Append(fv.NikomaKankei_PP[p1, p2]);
                    sb.Append(",");
                }

                sb.AppendLine();
            }

            return sb.ToString();
        }

        /// <summary>
        /// テキストを作ります。
        /// </summary>
        /// <param name="fv"></param>
        /// <returns></returns>
        public static string Format_KK(FeatureVector fv)
        {
            StringBuilder sb = new StringBuilder();

            //
            // コメント
            //
            sb.AppendLine("\"#紹介文\",");
            sb.AppendLine("\"#\",");
            sb.AppendLine("\"#ボナンザ６．０アレンジ式きふわらべ２駒関係\",");
            sb.AppendLine("\"#\",");
            sb.AppendLine("\"#----------------------------------------\",");
            sb.AppendLine("\"#ＫＫ表☆\",");
            sb.AppendLine("\"#----------------------------------------\",");
            sb.AppendLine("\"#\",");
            sb.AppendLine("\"#常に先手は正の数、後手は負の数の絶対値が大きい方が有利。０は互角。\",");

            //
            // 仕様バージョン
            //
            sb.AppendLine();
            sb.AppendLine("\"Version\",1.0,");
            sb.AppendLine();
            //----------------------------------------
            // K1 が 一段～九段
            //----------------------------------------
            for (int k1dan = 1; k1dan < 10; k1dan++)
            {
                // コメント行を作ります。
                sb.Append("\"#KK");//4文字
                string danStr = Conv_Int.ToKanSuji(k1dan);
                for (int suji = 9; suji > 0;suji-- )
                {
                    string sujiStr = Conv_Int.ToArabiaSuji(suji);
                    sb.Append(" ");
                    sb.Append(sujiStr);
                    sb.Append(danStr);
                    sb.Append("1P玉 vs2P玉   ");//15文字
                    for (int col = 0; col < 5; col++)
                    {
                        sb.Append("     ");//5文字
                    }
                    sb.Append("     ");//5文字
                }
                sb.AppendLine("\",");

                //----------------------------------------
                // K2 が 一段～九段
                //----------------------------------------
                for (int k2dan = 1; k2dan < 10; k2dan++)
                {
                    // 行頭
                    sb.Append("    ");//4文字
                    //----------------------------------------
                    // K1 が ９筋～１筋
                    //----------------------------------------
                    for (int k1suji = 9; k1suji > 0; k1suji--)
                    {
                        int k1masu = Util_Masu10.Handle_OkibaSujiDanToMasu(Okiba.ShogiBan, k1suji, k1dan);

                        //----------------------------------------
                        // K2 が ９筋～１筋
                        //----------------------------------------
                        for (int k2suji = 9; k2suji > 0; k2suji--)
                        {
                            int k2masu = Util_Masu10.Handle_OkibaSujiDanToMasu(Okiba.ShogiBan, k2suji, k2dan);
                            sb.Append( string.Format("{0,4}", Math.Round( fv.NikomaKankei_KK[k1masu, k2masu]),0) );
                            sb.Append(",");
                        }

                        // 表の横の隙間
                        sb.Append("    ");
                    }
                    // 次の段へ
                    sb.AppendLine();

                }
                // 段の隙間
                sb.AppendLine();
            }

            return sb.ToString();
        }

    }
}
