﻿using Grayscale.P021_ConstShogi_.L250____Const;

namespace Grayscale.P505_Atama_Unou_.L___250_Unou
{
    /// <summary>
    /// 二駒関係のＰ　調査項目
    /// </summary>
    public enum NikomaKankeiP_ChosaKomoku
    {

        // Ｐの１２２４種類の調査項目☆
        //                         （内訳
        //                                 ※まず、先手の駒
        //                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、  ※８１マス上の自分の駒
        //                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※自分の持ち駒
        //                                 
        //                                 ※次に、後手の駒
        //                                 歩1～81・香1～81・桂1～81・銀1～81・金1～81・飛1～81・角1～81、　※８１マス上の相手の駒
        //                                 歩0～18・香0～4・桂0～4・銀0～4・金0～4・飛0～2・角0～2、        ※相手の持ち駒
        //                         ）

        Ji__Ban_Fu__ = 0,
        Ji__Ban_Kyo_ = Ji__Ban_Fu__ + ConstShogi.BAN_SIZE,
        Ji__Ban_Kei_ = Ji__Ban_Kyo_ + ConstShogi.BAN_SIZE,
        Ji__Ban_Gin_ = Ji__Ban_Kei_ + ConstShogi.BAN_SIZE,
        Ji__Ban_Kin_ = Ji__Ban_Gin_ + ConstShogi.BAN_SIZE,
        Ji__Ban_Hi__ = Ji__Ban_Kin_ + ConstShogi.BAN_SIZE,
        Ji__Ban_Kaku = Ji__Ban_Hi__ + ConstShogi.BAN_SIZE,
        Ji__MotiFu__ = Ji__Ban_Kaku + ConstShogi.BAN_SIZE,
        Ji__MotiKyo_ = Ji__MotiFu__ + 19,
        Ji__MotiKei_ = Ji__MotiKyo_ + 5,
        Ji__MotiGin_ = Ji__MotiKei_ + 5,
        Ji__MotiKin_ = Ji__MotiGin_ + 5,
        Ji__MotiHi__ = Ji__MotiKin_ + 5,
        Ji__MotiKaku = Ji__MotiHi__ + 3,
        AiteBan_Fu__ = Ji__MotiKaku + 3,
        AiteBan_Kyo_ = AiteBan_Fu__ + ConstShogi.BAN_SIZE,
        AiteBan_Kei_ = AiteBan_Kyo_ + ConstShogi.BAN_SIZE,
        AiteBan_Gin_ = AiteBan_Kei_ + ConstShogi.BAN_SIZE,
        AiteBan_Kin_ = AiteBan_Gin_ + ConstShogi.BAN_SIZE,
        AiteBan_Hi__ = AiteBan_Kin_ + ConstShogi.BAN_SIZE,
        AiteBan_Kaku = AiteBan_Hi__ + ConstShogi.BAN_SIZE,
        AiteMotiFu__ = AiteBan_Kaku + ConstShogi.BAN_SIZE,
        AiteMotiKyo_ = AiteMotiFu__ + 19,
        AiteMotiKei_ = AiteMotiKyo_ + 5,
        AiteMotiGin_ = AiteMotiKei_ + 5,
        AiteMotiKin_ = AiteMotiGin_ + 5,
        AiteMotiHi__ = AiteMotiKin_ + 5,
        AiteMotiKaku = AiteMotiHi__ + 3
    }
}
