﻿
namespace Grayscale.P505_Atama_Unou_.L___250_Unou
{
    /// <summary>
    /// 飽きてくるカウンター。
    /// 
    /// 更新回数の累計。
    /// </summary>
    public interface TiredVector
    {
        /// <summary>
        /// 駒割の価値の更新回数☆
        /// </summary>
        int[] Komawari { get; set; }

        /// <summary>
        /// 二駒関係ＫＫ☆
        /// 
        /// 自玉の位置８１マス　×　相手玉の位置８１マスの更新回数☆
        /// </summary>
        int[,] NikomaKankei_KK { get; set; }

        /// <summary>
        /// 二駒関係ＫＰ
        /// 
        /// 自玉の位置８１マス　×　１２２４種類の調査項目の更新回数☆
        /// </summary>
        int[,] NikomaKankei_KP { get; set; }

        /// <summary>
        /// 二駒関係ＰＰ☆
        /// 
        /// １２２４種類の調査項目　×　１２２４種類の調査項目の更新回数☆
        /// </summary>
        int[,] NikomaKankei_PP { get; set; }

        
        /// <summary>
        /// ファイルから読み込みます。
        /// </summary>
        /// <param name="filepath"></param>
        bool Make_FromFile(string filepath);

        /// <summary>
        /// 0クリアーでデータを作成します☆
        /// </summary>
        void Make_Zero();

    }
}
