﻿using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using Grayscale.P507_Atama______.L___500_KyHandan;

namespace Grayscale.P507_Atama______.L500____KyHandan
{

    /// <summary>
    /// 局面評価の計算用の引数。
    /// </summary>
    public class KyHandanArgsImpl : KyHandanArgs
    {
        public TenonagareGenjo TenonagareGenjo { get { return this.tenonagareGenjo; } }
        private TenonagareGenjo tenonagareGenjo;

        public KifuNode Node { get { return this.node; } }
        private KifuNode node;

        public PlayerInfo PlayerInfo { get { return this.playerInfo; } }
        private PlayerInfo playerInfo;

        public UnouImpl Unou { get { return this.unou; } }
        private UnouImpl unou;

        public KyHandanArgsImpl(
            TenonagareGenjo tenonagareGenjo,
            KifuNode node,
            UnouImpl unou,
            PlayerInfo playerInfo
            )
        {
            this.tenonagareGenjo = tenonagareGenjo;
            this.node = node;
            this.unou = unou;
            this.playerInfo = playerInfo;
        }

    }
}
