﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P013_Collection_.L500____Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P153_KifuSfen___.L___250_Report;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P222_Log_Kaisetu.L250____Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P363_KyokumMoves.L250____Struct;
using Grayscale.P363_KyokumMoves.L500____Util;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P511_KifuWarabe_.L061____Util
{
    public abstract class Util_LogBuilder510
    {

        /// <summary>
        /// 盤１個分のログ。
        /// </summary>
        public static void Build_LogBoard(
            Node<Starbeamable, KyokumenWrapper> node_forLog,
            string nodePath,
            KifuNode niniNode,//任意のノード
            //KifuTree kifu_forAssert,
            ReportEnvironment reportEnvironment,
            KaisetuBoards logF_kiki,
            KwErrorHandler errH
            )
        {
            //
            // HTMLﾛｸﾞ
            //
            if (logF_kiki.boards.Count < 30)//出力件数制限
            {
                KaisetuBoard logBrd_move1 = new KaisetuBoard();

                List_OneAndMulti<Finger, SySet<SyElement>> komaBETUSusumeruMasus;
                //kifu_forAssert.AssertPside(niniNode, "Build_LogBoard nodePath=" + nodePath,errH);
                Playerside pside = niniNode.Value.ToKyokumenConst.KaisiPside;
                Util_KyokumenMoves.LA_Split_KomaBETUSusumeruMasus(
                    2,
                    node_forLog,
                    out komaBETUSusumeruMasus,
                    new MmGenjo_MovableMasuImpl(
                        true,//本将棋
                        niniNode.Value.ToKyokumenConst,//現在の局面
                        pside,
                        false
                        ),
                    new MmLogGenjoImpl(
                        0,//読み開始手目済み
                        logBrd_move1,
                        0,//現在の手済み
                        niniNode.Key,
                        errH
                    )
                );

                logBrd_move1.sasiteOrNull = niniNode.Key;

                logBrd_move1.YomikaisiTemezumi = niniNode.Value.ToKyokumenConst.Temezumi;//読み開始手目済み    // int.MinValue;
                logBrd_move1.Temezumi = int.MinValue;
                logBrd_move1.Score = (int)niniNode.KyHyoka.Total();

                logF_kiki.boards.Add(logBrd_move1);
            }
        }


    }
}
