﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P206_Json_______.L___500_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P511_KifuWarabe_.L100____Shogisasi;
using System.Collections.Generic;


namespace Grayscale.P511_KifuWarabe_.L___020_Kokoro
{


    public interface Kokoro
    {

        /// <summary>
        /// 「移動」タイプの狙いを作成します☆ｗ
        /// </summary>
        /// <param name="input_myPside"></param>
        /// <param name="save_node">狙い作成時の局面を状況として記録するために読取します。</param>
        /// <param name="forDebug_kifu"></param>
        /// <param name="input_seikaku"></param>
        void Omoituki(
            Playerside input_myPside,
            KifuNode save_node,
            Seikaku input_seikaku
            );



        /// <summary>
        /// 頭の隅コレクションのWrite。
        /// </summary>
        /// <param name="obj_sikouEngine"></param>
        void WriteTenonagare(object obj_sikouEngine, KwErrorHandler errH);

        Json_Val TenonagareToJsonVal();

        void ReadTenonagare();

        /// <summary>
        /// 頭の隅に置いてある、いくつかの手の流れ。
        /// </summary>
        List<Tenonagare> TenonagareItems { get; set; }

        void ClearTenonagare();

        void AddTenonagare(Tenonagare kiokuHow);

    }


}
