﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P511_KifuWarabe_.L___020_Kokoro;
using Grayscale.P511_KifuWarabe_.L___040_KyHyoka;

namespace Grayscale.P511_KifuWarabe_.L___100_Shogisasi
{

    /// <summary>
    /// 将棋指し。
    /// </summary>
    public interface Shogisasi
    {
        /// <summary>
        /// 局面評価ライター。
        /// </summary>
        KyHyokaWriter KyHyokaWriter { get; set; }

        /// <summary>
        /// 右脳。
        /// </summary>
        UnouImpl Unou { get; set; }

        /// <summary>
        /// 心エンジン。
        /// </summary>
        Kokoro Kokoro { get; set; }

        /// <summary>
        /// 対局開始のとき。
        /// </summary>
        void OnTaikyokuKaisi();

                
        /// <summary>
        /// 指し手を決めます。
        /// </summary>
        /// <param name="enableLog"></param>
        /// <param name="isHonshogi"></param>
        /// <param name="kifu"></param>
        /// <param name="playerInfo"></param>
        /// <param name="errH"></param>
        /// <returns></returns>
        KifuNode WA_Bestmove(
            bool isHonshogi,
            KifuTree kifu,
            PlayerInfo playerInfo,
            KwErrorHandler errH
            );

    }

}
