﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P703_ShogiGui___.L___500_Gui;
using Grayscale.P703_ShogiGui___.L500____GUI;
using Grayscale.P803_ShogiGuiVs_.L250____Engine;
using Grayscale.P803_ShogiGuiVs_.L250____ShogiEngine;
using System.Text;

namespace Grayscale.P803_ShogiGuiVs_.L500____GUI
{
    public class KifuNarabeVsImpl : KifuNarabeImpl, ShogiGui
    {

        public ShogiEngineLive ShogiEnginePrWrapperLauncher { get { return this.shogiEnginePrWrapperLauncher; } }
        private ShogiEngineLive shogiEnginePrWrapperLauncher;


        public KifuNarabeVsImpl():base()
        {
            this.shogiEnginePrWrapperLauncher = new ShogiEngineLiveImpl(this);
        }

        /// <summary>
        /// ************************************************************************************************************************
        /// 手番が替わったときの挙動を、ここに書きます。
        /// ************************************************************************************************************************
        /// </summary>
        public override void ChangeTurn( KwErrorHandler errH)
        {
            this.ShogiEnginePrWrapperLauncher.ChangeTurn99(this.Model_PnlTaikyoku.Kifu, errH);
        }

        /// <summary>
        /// 将棋エンジンに、終了するように促します。
        /// </summary>
        public override void Shutdown()
        {
            this.ShogiEnginePrWrapperLauncher.ShogiEngineManInterface.Shutdown();
        }

        /// <summary>
        /// 将棋エンジンに、ログを出すように促します。
        /// </summary>
        public override void Logdase()
        {
            this.ShogiEnginePrWrapperLauncher.ShogiEngineManInterface.Logdase();
        }

        
        /// <summary>
        /// ************************************************************************************************************************
        /// 将棋エンジンを起動します。
        /// ************************************************************************************************************************
        /// </summary>
        public override void Start(string shogiEngineFilePath)
        {
            this.ShogiEnginePrWrapperLauncher.Start(shogiEngineFilePath);
        }

        /// <summary>
        /// このアプリケーションソフトの開始時の処理。
        /// </summary>
        public new void Load_AsStart()
        {
            base.Load_AsStart();

            this.Data_Settei_Csv.Read_Add("../../Data/data_settei_vs.csv", Encoding.UTF8);
            this.Data_Settei_Csv.DebugOut();
            this.WidgetLoaders.Add(new WidgetsLoader_KifuNarabeVs("../../Data/data_widgets_KifuNarabeVs.csv"));

        }

    }
}
