﻿using Grayscale.P321_KyokumHyoka.L___250_Struct;

namespace Grayscale.P321_KyokumHyoka.L250____Struct
{

    /// <summary>a
    /// 指定局面限定での評価明細の項目値。内訳は省略可能。
    /// 
    /// 評価を付けます。
    /// </summary>
    public class KyHyokaMeisai_KoumokuImpl : KyHyokaMeisai_Koumoku
    {
        /// <summary>
        /// 集計後の局面評価値。
        /// </summary>
        public double Score { get { return this.score; } }
        private double score;

        /// <summary>
        /// 内訳。
        /// </summary>
        public string Utiwake { get { return this.utiwake; } }
        private string utiwake;

        /// <summary>
        /// 内訳の自信クラス
        /// </summary>
        public KyJisinClass Utiwake_jisinClass { get { return this.utiwake_jisinClass; } }
        private KyJisinClass utiwake_jisinClass;

        public KyHyokaMeisai_KoumokuImpl(double score, string utiwake, KyJisinClass utiwake_jisinClass)
        {
            this.score = score;
            this.utiwake = utiwake;
            this.utiwake_jisinClass = utiwake_jisinClass;
        }

    }
}
