﻿using Grayscale.P321_KyokumHyoka.L___250_Struct;
using System;

namespace Grayscale.P321_KyokumHyoka.L500____Util
{
    public abstract class Util_KyHyoka
    {
        public static double Keisan(double jisinTen, KyHyokaSaido saido, double jisinClassBetu_Bairitu)//double[] classbetuScoreBairitu
        {
            //
            // 細度の上限の絶対値。
            //
            int syosu_keta;
            Conv_Saido.ToSyosuKeta(saido, out syosu_keta);

            //
            // (double)-1～0～1 の範囲内に丸める。
            //
            jisinTen = Util_KyHyoka.TrimJisinTen_ByLimit(jisinTen, syosu_keta);

            ////
            //// 評価クラス。
            ////
            //KyJisinClass kyHyokaClass = Util_KyHyoka.JisinTen_ToJisinClass(jisinTen);


            return jisinClassBetu_Bairitu * jisinTen;
            //return classbetuScoreBairitu[(int)kyHyokaClass] * jisinTen;
        }


        /// <summary>
        /// 上限値以上、下限値以下を丸めます。
        /// </summary>
        /// <returns></returns>
        private static double TrimJisinTen_ByLimit(double jisinTen, int syosu_keta)
        {
            // 丸め
            if (syosu_keta != 0)
            {
                // 0.0～1.0　にしたり、
                // 0.00～1.00 にしたりします。
                jisinTen = Math.Round(jisinTen, syosu_keta);
            }

            // 上限、下限があります。
            double limitAbs = 1.0d;
            if (limitAbs < jisinTen)
            {
                jisinTen = limitAbs;
            }
            else if (jisinTen < -limitAbs)
            {
                jisinTen = -limitAbs;
            }


            return jisinTen;
        }
    }
}
