﻿
namespace Grayscale.P321_KyokumHyoka.L___250_Struct
{
    /// <summary>
    /// 評価項目名＋自信クラス名
    /// 
    /// ランキング用
    /// </summary>
    public enum KyHyokaKoumokuName
    {
        /// <summary>
        /// エラー用。
        /// </summary>
        Unknown___________=0,
        //Unknown______________,

        /// <summary>
        /// 玉の守り
        /// </summary>
        GyokuNoMamori_____,
        //GyokuNoMamori______M_,
        //GyokuNoMamori______A_,
        //GyokuNoMamori______B1,
        //GyokuNoMamori______B2,
        //GyokuNoMamori______C1,
        //GyokuNoMamori______C2,

        /// <summary>
        /// 紐付き
        /// </summary>
        Himoduki__________,
        //Himoduki___________M_,
        //Himoduki___________A_,
        //Himoduki___________B1,
        //Himoduki___________B2,
        //Himoduki___________C1,
        //Himoduki___________C2,

        /// <summary>
        /// 移動
        /// </summary>
        Ido_______________,
        //Ido________________M_,
        //Ido________________A_,
        //Ido________________B1,
        //Ido________________B2,
        //Ido________________C1,
        //Ido________________C2,

        /// <summary>
        /// 角頭の紐付き
        /// </summary>
        KakuTouNoHimoduki_,
        //KakuTouNoHimoduki__M_,
        //KakuTouNoHimoduki__A_,
        //KakuTouNoHimoduki__B1,
        //KakuTouNoHimoduki__B2,
        //KakuTouNoHimoduki__C1,
        //KakuTouNoHimoduki__C2,

        /// <summary>
        /// 気まぐれ
        /// </summary>
        Kimagure__________,
        //Kimagure___________M_,
        //Kimagure___________A_,
        //Kimagure___________B1,
        //Kimagure___________B2,
        //Kimagure___________C1,
        //Kimagure___________C2,

        /// <summary>
        /// 駒得
        /// </summary>
        KomaDoku__________,
        //KomaDoku___________M_,
        //KomaDoku___________A_,
        //KomaDoku___________B1,
        //KomaDoku___________B2,
        //KomaDoku___________C1,
        //KomaDoku___________C2,

        /// <summary>
        /// 目の前の歩を取れ
        /// </summary>
        MenomaenoFuWoTore_,
        //MenomaenoFuWoTore__M_,
        //MenomaenoFuWoTore__A_,
        //MenomaenoFuWoTore__B1,
        //MenomaenoFuWoTore__B2,
        //MenomaenoFuWoTore__C1,
        //MenomaenoFuWoTore__C2,

        /// <summary>
        /// 二駒関係KK,KP,PP
        /// </summary>
        NikomaKankeiKkKpPp,
        //NikomaKankeiKkKpPp_M_,
        //NikomaKankeiKkKpPp_A_,
        //NikomaKankeiKkKpPp_B1,
        //NikomaKankeiKkKpPp_B2,
        //NikomaKankeiKkKpPp_C1,
        //NikomaKankeiKkKpPp_C2,

        /// <summary>
        /// 通し
        /// </summary>
        Toosi_____________,
        //Toosi______________M_,
        //Toosi______________A_,
        //Toosi______________B1,
        //Toosi______________B2,
        //Toosi______________C1,
        //Toosi______________C2,

        /// <summary>
        /// 取る
        /// </summary>
        Toru______________,
        //Toru_______________M_,
        //Toru_______________A_,
        //Toru_______________B1,
        //Toru_______________B2,
        //Toru_______________C1,
        //Toru_______________C2,

        /// <summary>
        /// 突き捨て
        /// </summary>
        Tukisute__________,
        //Tukisute___________M_,
        //Tukisute___________A_,
        //Tukisute___________B1,
        //Tukisute___________B2,
        //Tukisute___________C1,
        //Tukisute___________C2,
    }
}
