﻿
namespace Grayscale.P321_KyokumHyoka.L___250_Struct
{
    /// <summary>
    /// 自信点の細度。
    /// 
    /// 正の数は先手有利、負の数は後手有利。
    /// </summary>
    public enum KyHyokaSaido
    {
        /// <summary>
        /// 集計用。
        /// </summary>
        Saigoni_Total,

        /// <summary>
        /// 百。0.00～1.00。
        /// </summary>
        Hyaku_bunnoichi,
        /// <summary>
        /// 千。0.000～1.000。
        /// </summary>
        Sen_bunnoichi,
        /// <summary>
        /// 万。0.0000～1.0000。
        /// </summary>
        Man_bunnoichi,
        /// <summary>
        /// 十万。0.00000～1.00000。
        /// </summary>
        Jyuman_bunnoichi,
        /// <summary>
        /// 百万。0.000000～1.000000。
        /// </summary>
        Hyakuman_bunnoichi
    }
}
