﻿
namespace Grayscale.P321_KyokumHyoka.L___250_Struct
{
    /// <summary>
    /// 自信クラス名。
    /// </summary>
    public enum KyJisinClass
    {
        /// <summary>
        /// [0] エラー用。
        /// </summary>
        UNKNOWN = 0,
        /// <summary>
        /// 131分率でいうところの、上位1位から数えて、上位１位。
        /// </summary>
        M_,
        /// <summary>
        /// 131分率でいうところの、上位1位から数えて、上位2～11位。
        /// </summary>
        A_,
        /// <summary>
        /// 131分率でいうところの、上位1位から数えて、上位12～24位。
        /// </summary>
        B1,
        /// <summary>
        /// 131分率でいうところの、上位1位から数えて、上位25～50位。
        /// </summary>
        B2,
        /// <summary>
        /// 131分率でいうところの、上位1位から数えて、上位51～84位。
        /// </summary>
        C1,
        /// <summary>
        /// 131分率でいうところの、上位1位から数えて、上位85～131位。
        /// </summary>
        C2
    }
}
