﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P234_Komahaiyaku.L500____Util;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P292_JsaFugo____.L250____Struct;
using Grayscale.P292_JsaFugo____.L500____Util;
using Grayscale.P295_JsaFugoWrit.L500____Writer;

namespace Grayscale.P322_KifuTree___.L500____Util
{
    public abstract class Conv_Node322
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="siteiNode">keyで指し手の指定、かつ、１つ前のノードに移動するのに使います。</param>
        /// <param name="genKyokumenWrapper">現局面です。</param>
        /// <param name="errH"></param>
        /// <returns></returns>
        public static string ToSasite(
            Node<Starbeamable, KyokumenWrapper> siteiNode,
            KyokumenWrapper genKyokumenWrapper,
            KwErrorHandler errH
            )
        {
            RO_Star koma = Util_Koma.AsKoma(((Starbeamable)siteiNode.Key).LongTimeAgo);

            JsaFugoImpl fugo = Array_JsaFugoCreator15.ItemMethods[(int)Util_Komahaiyaku184.Syurui(koma.Haiyaku)](siteiNode.Key, genKyokumenWrapper, errH);//「▲２二角成」なら、馬（dst）ではなくて角（src）。

            return Util_Translator_JsaFugo.ToString_UseDou(fugo, siteiNode);
        }

    }
}
