﻿using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P307_UtilSky____.L500____Util;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P322_KifuTree___.L250____Struct;
using System.Collections.Generic;
//スプライト番号

namespace Grayscale.P322_KifuTree___.L500____Util
{
    public abstract class Conv_SasitebetuKyokumenwrappers
    {
        /// <summary>
        /// どの駒が、どのマスへ動ける、というリストを、ハブ・ノードへ変換します。
        /// </summary>
        /// <param name="sasitebetuKyokumenwrappers"></param>
        /// <param name="nextTebanside"></param>
        /// <returns></returns>
        public static KifuNode ToNextNodes_AsHubNode(
            Dictionary<Starbeamable, KyokumenWrapper> sasitebetuKyokumenwrappers,
            KifuNode to_parentNode,//親となる予定のノード
            //KifuTree kifu_forAssert,
            Playerside nextTebanside
            )
        {
            KifuNode hubNode = new KifuNodeImpl(null, null);

            foreach (KeyValuePair<Starbeamable, KyokumenWrapper> nextNode in sasitebetuKyokumenwrappers)
            {
                KifuNode newChild = new KifuNodeImpl(nextNode.Key, nextNode.Value);
                //kifu_forAssert.AssertChildPside(to_parentNode.Value.ToKyokumenConst.KaisiPside, newChild.Value.ToKyokumenConst.KaisiPside);//

                hubNode.PutAdd_ChildNode(
                    Conv_Sasite307.ToSfenFugo(nextNode.Key),
                    newChild
                    );
            }

            return hubNode;
        }

    }
}
