﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P003_Log________.L500____Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P211_WordShogi__.L250____Word;
using Grayscale.P213_Komasyurui_.L250____Word;
using Grayscale.P213_Komasyurui_.L500____Util;
using Grayscale.P214_Masu_______.L250____Struct;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P224_Sky________.L500____Struct;
using Grayscale.P234_Komahaiyaku.L500____Util;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P256_SeizaFinger.L250____Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using System.Text.RegularExpressions;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P341_Ittesasu___.L500____UtilA
{
    public abstract class Conv_SfenSasitesText
    {
        /// <summary>
        /// ************************************************************************************************************************
        /// テキスト形式の符号「7g7f 3c3d 6g6f…」の最初の要素を、切り取ってプロセスに変換します。
        /// ************************************************************************************************************************
        /// 
        /// [再生]、[コマ送り]で利用。
        /// </summary>
        /// <returns></returns>
        public static bool ToTokens(
            string inputLine,
            out string str1,
            out string str2,
            out string str3,
            out string str4,
            out string str5,
            out string rest,
            KifuTree kifu,
            KwLogger logTag
            )
        {
            bool successful = false;
            //nextTe = null;
            rest = inputLine;
            str1 = "";
            str2 = "";
            str3 = "";
            str4 = "";
            str5 = "";

            //System.C onsole.WriteLine("TuginoItte_Sfen.GetData_FromText:text=[" + text + "]");

            try
            {



                //------------------------------------------------------------
                // リスト作成
                //------------------------------------------------------------
                Regex regex = new Regex(
                    @"^\s*([123456789PLNSGKRB])([abcdefghi\*])([123456789])([abcdefghi])(\+)?",
                    RegexOptions.Singleline
                );

                MatchCollection mc = regex.Matches(inputLine);
                foreach (Match m in mc)
                {

                    try
                    {

                        if (0 < m.Groups.Count)
                        {
                            successful = true;

                            // 残りのテキスト
                            rest = inputLine.Substring(0, m.Index) + inputLine.Substring(m.Index + m.Length, inputLine.Length - (m.Index + m.Length));

                            str1 = m.Groups[1].Value;
                            str2 = m.Groups[2].Value;
                            str3 = m.Groups[3].Value;
                            str4 = m.Groups[4].Value;
                            str5 = m.Groups[5].Value;
                        }

                        // 最初の１件だけ処理して終わります。
                        break;
                    }
                    catch (Exception ex) { OwataMinister.ERROR.DonimoNaranAkirameta(ex, "moves解析中☆"); throw ex; }
                }

                rest = rest.Trim();

            }
            catch (Exception ex) { OwataMinister.ERROR.DonimoNaranAkirameta(ex, "moves解析中☆"); throw ex; }

            return successful;
        }
    }
}
