﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P011_Random_____.L500____Struct;
using Grayscale.P013_Collection_.L500____Struct;
using Grayscale.P015_Syugoron___.L___250_Struct;
using Grayscale.P212_ConvPside__.L500____Converter;
using Grayscale.P214_Masu_______.L500____Util;
using Grayscale.P218_Starlight__.L___500_Struct;
using Grayscale.P222_Log_Kaisetu.L250____Struct;
using Grayscale.P226_Tree_______.L___500_Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P238_Seiza______.L500____Util;
using Grayscale.P247_KyokumenWra.L500____Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P322_KifuTree___.L500____Util;
using Grayscale.P353_Conv_Sasu__.L500____Converter;
using Grayscale.P354_Util_SasuEx.L500____Util;
using Grayscale.P362_LegalMove__.L500____Util;
using Grayscale.P363_KyokumMoves.L250____Struct;
using Grayscale.P363_KyokumMoves.L500____Util;
using Grayscale.P371_Tansaku____.L___500_Tansaku;
using Grayscale.P371_Tansaku____.L500____Struct;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

#if DEBUG
using Grayscale.P306_LogGraphiEx.L500____Util;
#endif

namespace Grayscale.P375_TansaFukasa.L500____Struct
{

    /// <summary>
    /// 探索ルーチン
    /// </summary>
    public class Tansaku_FukasaYusen_Routine : Tansaku_Routine
    {

        public Tansaku_Genjo CreateGenjo(
            KifuTree kifu,
            bool isHonshogi,
            KwErrorHandler errH
            )
        {
            // TODO:ここではログを出力せずに、ツリーの先端で出力したい。
            KaisetuBoards logF_moveKiki = new KaisetuBoards();

            // TODO:「読む」と、ツリー構造が作成されます。
            //int[] yomuLimitter = new int[]{
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    100, // 読みの2手目の横幅
            //    100, // 読みの3手目の横幅
            //    //2, // 読みの4手目の横幅
            //    //1 // 読みの5手目の横幅
            //};

            //// ↓これなら１手１秒で指せる☆
            //int[] yomuLimitter = new int[]{
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    150, // 読みの2手目の横幅
            //    150, // 読みの3手目の横幅
            //    //2 // 読みの4手目の横幅
            //    //1 // 読みの5手目の横幅
            //};

            //int[] yomuLimitter = new int[]{
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    600, // 読みの2手目の横幅
            //    600, // 読みの3手目の横幅
            //};

            //ok
            //int[] yomuLimitter = new int[]{
            //    0,   // 現局面は無視します。
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    600, // 読みの2手目の横幅
            //};


            // ２手の読み。
            int[] yomuLimitter = new int[]{
                0,   // 現局面は無視します。
                600, // 読みの1手目の横幅   // 王手回避漏れのために、１手目は、合法手全読み(約600)は必要です。
                600, // 読みの2手目の横幅
            };

            /*
            // ３手の読み。
            int[] yomuLimitter = new int[]{
                0,   // 現局面は無視します。
                600, // 読みの1手目の横幅   // 王手回避漏れのために、１手目は、合法手全読み(約600)は必要です。
                600, // 読みの2手目の横幅
                600, // 読みの3手目の横幅
            };
             */

#if DEBUG
            // ログの出力数を減らすために、読みを弱くします。

            //yomuLimitter = new int[]{
            //    0,  // 現局面は無視します。
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    100, // 読みの2手目の横幅
            //    100 // 読みの3手目の横幅
            //};

            yomuLimitter = new int[]{
                0,  // 現局面は無視します。
                600, // 読みの1手目の横幅   // 王手回避漏れのために、１手目は、合法手全読み(約600)は必要です。
                600, // 読みの2手目の横幅
                //600 // 読みの3手目の横幅
            };

            //yomuLimitter = new int[]{
            //    600, // 読みの1手目の横幅   // 王手回避漏れのために、合法手全読み(約600)は必要です。
            //    600, // 読みの2手目の横幅
            //    600, // 読みの3手目の横幅
            //    100,
            //    100
            //};

#endif
            Tansaku_Args args = new Tansaku_ArgsImpl(isHonshogi, yomuLimitter, logF_moveKiki);
            Tansaku_Genjo genjo = new Tansaku_GenjoImpl(
                (KifuNode)kifu.CurNode,//読み開始局面。このノードに、ツリーをぶら下げていきます。
                args
                );

            return genjo;
        }

        /// <summary>
        /// 読む。
        /// 
        /// 棋譜ツリーを作成します。
        /// </summary>
        /// <param name="kifu">この棋譜ツリーの現局面に、次局面をぶら下げて行きます。</param>
        /// <param name="enableLog"></param>
        /// <param name="isHonshogi"></param>
        /// <param name="logTag"></param>
        /// <returns></returns>
        public void WAA_Yomu_Start(
            KifuTree kifu,
            bool isHonshogi,
            KwErrorHandler errH
            )
        {
            int exceptionArea = 0;

            try
            {
                exceptionArea = 10;
                Tansaku_Genjo genjo = this.CreateGenjo(kifu, isHonshogi, errH);
                Tansaku_FukasaYusen_Routine.WAAA_Yomu_Loop(
                    genjo,
                    //kifu,
                    errH
                    );

                exceptionArea = 20;
                if (0 < genjo.Args.LogF_moveKiki.boards.Count)//ﾛｸﾞが残っているなら
                {
                    ////
                    //// ログの書き出し
                    ////
                    //Util_GraphicalLog.WriteHtml5(
                    //    true,//enableLog,
                    //    "SasiteRoutine#Yomi_NextNodes(00)新ログ",
                    //    "[" + Util_GraphicalLog.BoardFileLog_ToJsonStr(genjo.Args.LogF_moveKiki) + "]"
                    //);

                    // 書き出した分はクリアーします。
                    genjo.Args.LogF_moveKiki.boards.Clear();
                }
            }
            catch (Exception ex)
            {
                switch (exceptionArea)
                {
                    case 10:
                        {
                            //>>>>> エラーが起こりました。
                            string message = ex.GetType().Name + " " + ex.Message + "：棋譜ツリーの読みの中盤５０です。：";
                            Debug.Fail(message);

                            // どうにもできないので  ログだけ取って、上に投げます。
                            errH.Logger.WriteLine_Error(message);
                            throw ex;
                        }
                    case 20:
                        {
                            errH.DonimoNaranAkirameta(ex, "棋譜ツリーの読みの後半９０です。"); throw ex;
                        }
                    default: throw ex;
                }
            }
        }



        /// <summary>
        /// 棋譜ツリーに、ノードを追加していきます。再帰します。
        /// </summary>
        /// <param name="node_yomiCur"></param>
        /// <param name="genjo"></param>
        /// <param name="isAiteban"></param>
        /// <param name="errH"></param>
        private static void WAAA_Yomu_Loop(
            Tansaku_Genjo genjo,
            //KifuTree kifu_forAssert,
            KwErrorHandler errH
            )
        {
            int exceptionArea = 0;

            //
            // まず前提として、
            // 現手番の「被王手の局面」だけがピックアップされます。
            // これはつまり、次の局面がないときは、その枝は投了ということです。
            //

            KifuNode hub_NextNodes;
            try
            {
                exceptionArea = 10;
                // このハブ・ノード自身は空っぽで、ハブ・ノードの次ノードが、次局面のリストになっています。
                hub_NextNodes = Tansaku_FukasaYusen_Routine.WAAAA_CreateNextNodes(genjo,
                    //kifu_forAssert,
                    errH);

                exceptionArea = 20;
                //
                // （２）現在の局面に、読んだ局面を継ぎ足します。
                //
                genjo.Node_yomiNext.PutAppdendNextNodes(hub_NextNodes, genjo.Node_yomiNext
                    //, kifu_forAssert
                    );

                exceptionArea = 30;
                Tansaku_FukasaYusen_Routine.WAAAA_Create_NextBranch(genjo, hub_NextNodes,
                    //kifu_forAssert,
                    errH);
            }
            catch (Exception ex)
            {
                switch (exceptionArea)
                {
                    case 10:
                        {
                            errH.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの前半１０です。"); throw ex;
                        }
                    case 20:
                        {
                            errH.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの前半２０です。"); throw ex;
                        }
                    case 30:
                        {
                            errH.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの後半７０です。"); throw ex;
                        }
                    default: throw ex;
                }
            }

            //try
            //{
            //    if (genjo.Node_yomiNext.IsLeaf)//現在ノード
            //    {
            //    }
            //    else
            //    {
            //        // TODO: 葉ノードではない（次のノードがある）なら、次枝読みが終わったので、この中間ノードの局面データは使われませんので破棄します。
            //        //node_yomiCur.Lock_Kyokumendata();
            //    }

            //}
            //catch (Exception ex)
            //{
            //    errH.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの後半９０です。"); throw ex;
            //}

        }

        /// <summary>
        /// まず前提として、
        /// 現手番の「被王手の局面」だけがピックアップされます。
        /// これはつまり、次の局面がないときは、その枝は投了ということです。
        /// </summary>
        /// <param name="enableLog"></param>
        /// <param name="isHonshogi"></param>
        /// <param name="yomuDeep"></param>
        /// <param name="pside_yomiCur"></param>
        /// <param name="node_yomiCur"></param>
        /// <param name="logF_moveKiki"></param>
        /// <param name="logTag"></param>
        /// <returns>複数のノードを持つハブ・ノード</returns>
        private static KifuNode WAAAA_CreateNextNodes(
            Tansaku_Genjo genjo,
            //KifuTree kifu_forAssert,
            KwErrorHandler errH
            )
        {
            int exceptionArea = 0;
            KifuNode hubNode;

            try
            {
                exceptionArea = 10;
                // 利きから、被王手の局面を除いたハブノード
                // このハブ・ノード自身は空っぽで、ハブ・ノードの次ノードが、次局面のリストになっています。

                //
                // ①現手番の駒の移動可能場所_被王手含む
                //
                MmGenjo_MovableMasuImpl mm_genjo = null;
                mm_genjo = new MmGenjo_MovableMasuImpl(
                        genjo.Args.IsHonshogi,//本将棋か
                        genjo.Node_yomiNext.Value.ToKyokumenConst,//現在の局面  // FIXME:Lockすると、ここでヌルになる☆
                        genjo.Node_yomiNext.Value.ToKyokumenConst.KaisiPside,//手番
                        false//相手番か
                        );


                exceptionArea = 20;
                MmLogGenjoImpl mm_log;
                KaisetuBoard logBrd_move1;// 盤１個分のログの準備
                Tansaku_FukasaYusen_Routine.Log1(genjo, out mm_log, out logBrd_move1, errH);

                List_OneAndMulti<Finger, SySet<SyElement>> komaBETUSusumeruMasus;
                Util_KyokumenMoves.LA_Split_KomaBETUSusumeruMasus(
                    1,
                    genjo.Node_yomiNext,//node_forLog
                    out komaBETUSusumeruMasus,//進めるマス
                    mm_genjo,
                    mm_log
                );

//#if DEBUG
//                System.Console.WriteLine("komaBETUSusumeruMasusの全要素＝" + Util_List_OneAndMultiEx<Finger, SySet<SyElement>>.CountAllElements(komaBETUSusumeruMasus));
//#endif
//#if DEBUG
//                string jsaSasiteStr = Util_Translator_Sasite.ToSasite(genjo.Node_yomiNext, genjo.Node_yomiNext.Value, errH);
//                System.Console.WriteLine("[" + jsaSasiteStr + "]の駒別置ける升 調べ\n" + Util_List_OneAndMultiEx<Finger, SySet<SyElement>>.Dump(komaBETUSusumeruMasus, genjo.Node_yomiNext.Value.ToKyokumenConst));
//#endif
                //Sasiteseisei_FukasaYusen_Routine.Log2(genjo, logBrd_move1, errH);//ログ試し

                


                //
                // ②利きから、被王手の局面を除いたハブノード
                //
                if (genjo.Args.IsHonshogi)
                {
                    //----------------------------------------
                    // 本将棋
                    //----------------------------------------
                    exceptionArea = 30;
                    // 指定局面での全ての指し手。
                    Maps_OneAndMulti<Finger, Starbeamable> komaBETUAllSasites = Conv_KomabetuSusumeruMasus.ToKomaBETUAllSasites(
                        komaBETUSusumeruMasus, genjo.Node_yomiNext);

//#if DEBUG
//                    System.Console.WriteLine("komaBETUAllSasitesの全要素＝" + Util_Maps_OneAndMultiEx<Finger, SySet<SyElement>>.CountAllElements(komaBETUAllSasites));
//#endif
                    

                    // 本将棋の場合、王手されている局面は削除します。
                    hubNode = Util_LegalMove.LA_RemoveMate(
                        genjo.YomikaisiTemezumi,
                        genjo.Args.IsHonshogi,
                        komaBETUAllSasites,//駒別の全ての指し手
                        genjo.Node_yomiNext,
                        //kifu_forAssert,
                        genjo.Args.LogF_moveKiki,//利き用
                        "読みNextルーチン",
                        errH);


                    exceptionArea = 40;
                    //
                    // 成りの指し手を追加します。
                    //
                    Util_SasuEx.AddNariSasite(genjo.Node_yomiNext, hubNode,
                        //kifu_forAssert,
                        errH);

                    //Util_Converter04A.AssertNariSasite(hubNode, "#WAAAA_CreateNextNodes(2)");//ここで消えていた☆
                }
                else
                {
                    //----------------------------------------
                    // 本将棋じゃないもの
                    //----------------------------------------
                    exceptionArea = 50;

                    //----------------------------------------
                    // 駒別置ける升　→　指し手別局面
                    //----------------------------------------
                    //
                    // １対１変換
                    //
                    //kifu_forAssert.AssertChildPside(genjo.Node_yomiNext.Value.ToKyokumenConst.KaisiPside, genjo.Pside_teban);
                    Dictionary<Starbeamable, KyokumenWrapper> ss = Conv_KomabetuMasus.KomabetuMasus_ToSasitebetuSky(
                        komaBETUSusumeruMasus,
                        genjo.Node_yomiNext.Value.ToKyokumenConst,
                        errH
                        );

#if DEBUG
                    System.Console.WriteLine("駒別置ける升="+komaBETUSusumeruMasus.Items.Count+"件。　指し手別局面="+ss.Count+"件。");
                    Debug.Assert(komaBETUSusumeruMasus.Items.Count == ss.Count, "変換後のデータ件数が異なります。[" + komaBETUSusumeruMasus.Items.Count + "]→["+ss.Count+"]");
#endif

                    hubNode = Conv_SasitebetuKyokumenwrappers.ToNextNodes_AsHubNode(
                        ss,
                        genjo.Node_yomiNext,
                        //kifu_forAssert,
                        Conv_Playerside.Reverse(genjo.Node_yomiNext.Value.ToKyokumenConst.KaisiPside)//FIXME:手番をひっくり返している？？
                        );

                }
                exceptionArea = 0;

            }
            catch (Exception ex)
            {
                switch (exceptionArea)
                {
                    case 10:
                        {
                            errH.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの前半１０です。"); throw ex;
                        }
                    case 20:
                        {
                            errH.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの前半３０です。"); throw ex;
                        }
                    case 30:
                        {
                            errH.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの中盤５０です。"); throw ex;
                        }
                    case 40:
                        {
                            errH.DonimoNaranAkirameta(ex, "王手局面除去後に成りの指し手を追加していた時です。"); throw ex;
                        }
                    case 50:
                        {
                            errH.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの後半９０です。"); throw ex;
                        }
                    default: throw ex;
                }
            }


            return hubNode;
        }
        private static void Log1(
            Tansaku_Genjo genjo,
            out MmLogGenjoImpl out_mm_log,
            out KaisetuBoard out_logBrd_move1,
            KwErrorHandler errH
        )
        {
            out_logBrd_move1 = new KaisetuBoard();// 盤１個分のログの準備

            try
            {
                out_mm_log = new MmLogGenjoImpl(
                        genjo.YomikaisiTemezumi,
                        out_logBrd_move1,//ログ？
                        genjo.Node_yomiNext.Value.ToKyokumenConst.Temezumi,//手済み
                        genjo.Node_yomiNext.Key,//指し手
                        errH//ログ
                    );
            }
            catch (Exception ex)
            {
                errH.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの前半２０です。"); throw ex;
            }
        }
        private static void Log2(
            Tansaku_Genjo genjo,
            KaisetuBoard logBrd_move1,
            KwErrorHandler errH
        )
        {
            try
            {
                logBrd_move1.sasiteOrNull = genjo.Node_yomiNext.Key;


                RO_Star srcKoma = Util_Koma.AsKoma(logBrd_move1.sasiteOrNull.LongTimeAgo);
                RO_Star dstKoma = Util_Koma.AsKoma(logBrd_move1.sasiteOrNull.Now);


                // ログ試し
                logBrd_move1.Arrow.Add(new Gkl_Arrow(Util_Masu10.AsMasuNumber(srcKoma.Masu), Util_Masu10.AsMasuNumber(dstKoma.Masu)));
                genjo.Args.LogF_moveKiki.boards.Add(logBrd_move1);
            }
            catch (Exception ex)
            {
                errH.DonimoNaranAkirameta(ex, "棋譜ツリーの読みループの作成次ノードの前半４０です。"); throw ex;
            }
        }


        /// <summary>
        /// 次の枝を作成します。
        /// </summary>
        private static void WAAAA_Create_NextBranch(
            Tansaku_Genjo genjo,
            Node<Starbeamable, KyokumenWrapper> hubNode_genTeban,
            //KifuTree kifu_forAssert,
            KwErrorHandler errH
            )
        {
            // （３）次のノードをシャッフルします。
            List<KifuNode> nextNodes_shuffled = Conv_NextNodes.ToList(hubNode_genTeban);
            LarabeShuffle<KifuNode>.Shuffle_FisherYates(ref nextNodes_shuffled);

            int yomiDeep = genjo.Node_yomiNext.Value.ToKyokumenConst.Temezumi - genjo.YomikaisiTemezumi + 1;

            // （４）次の局面
            int wideCount = 0;
            foreach (KifuNode nextNode in nextNodes_shuffled)
            {
                // （５）読みの深さ指定以降なら、横幅制限
                if (1 < yomiDeep)
                {
                    if (genjo.Args.YomuLimitter[yomiDeep] <= wideCount)
                    {
                        break;// もう次の手の横には読まない。
                    }
                }


                // 《８》カウンターを次局面へ（２手目の読み）

                // 《９》まだ深く読むなら
                if (yomiDeep + 1 < genjo.Args.YomuLimitter.Length)
                {
                    // カウントを１上げます。
                    KifuNode oldNode = genjo.Node_yomiNext;//退避
                    genjo.SetNode_yomiNext( nextNode);//手番がひっくり返っていて、手目済みカウントも１つ増えているはずのノード。
                    Tansaku_FukasaYusen_Routine.WAAA_Yomu_Loop( genjo,
                        //kifu_forAssert,
                        errH);

                    // カウントを1戻します。
                    genjo.SetNode_yomiNext( oldNode);//元に戻します。
                }
                else
                {
                    // もう深くよまないなら
                }

                wideCount++;
            }


            if (genjo.Args.YomuLimitter.Length <= yomiDeep + 1)//もう深く読まないなら
            {
#if DEBUG
                bool enableLog = false;
                //
                // ログの書き出し
                //
                Util_GraphicalLog.WriteHtml5(
                    enableLog,
                    "指し手生成ログA",
                    "[" + Conv_KaisetuBoards.ToJsonStr(genjo.Args.LogF_moveKiki) + "]"
                );
#endif
                // 書き出した分はクリアーします。
                genjo.Args.LogF_moveKiki.boards.Clear();
            }
        }

    }

}
