﻿using Grayscale.P214_Masu_______.L250____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P507_Atama______.L___250_KyHandanOrder;

namespace Grayscale.P500_Kokoro_____.L___500_Kokoro
{

    /// <summary>
    /// 頭の隅に置いてある、手の流れ。
    /// 
    /// 引数のようなもの。計測や、点数付けに渡されます。
    /// </summary>
    public interface TenonagareGenjo
    {
        /// <summary>
        /// 判断オーダー名。
        /// </summary>
        KyHandanOrderName HandanOrderName { get; }

        /// <summary>
        /// 狙っている「手の流れ」の名前。
        /// 例えば、「KakutouNoHimoduki」とか。
        /// </summary>
        TenonagareName Name { get; }

        /// <summary>
        /// どのマスを
        /// </summary>
        Basho Masu { get; }

        /// <summary>
        /// どの駒が
        /// </summary>
        RO_Star Koma1 { get; }

        /// <summary>
        /// どの駒が＜その２＞
        /// </summary>
        RO_Star Koma2 { get; }// set;

    }


}
