﻿
using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;

namespace Grayscale.P507_Atama______.L___500_KyHandan
{

    /// <summary>
    /// 局面評価の判断。
    /// </summary>
    public interface KyHandan
    {

        /// <summary>
        /// 名前。
        /// </summary>
        TenonagareName Name { get; }

        /// <summary>
        /// 0.0d ～100.0d の範囲で、評価値を返します。数字が大きい方がグッドです。
        /// </summary>
        /// <param name="keisanArgs"></param>
        /// <returns></returns>
        void Keisan(out KyHyokaMeisai_Koumoku kyokumenScore, KyHandanArgs keisanArgs, KwErrorHandler errH);

    }
}
