﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P153_KifuSfen___.L___125_Struct;
using Grayscale.P206_Json_______.L___500_Struct;
using Grayscale.P206_Json_______.L500____Struct;
using Grayscale.P214_Masu_______.L250____Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P500_Kokoro_____.L500____Kokoro;
using Grayscale.P507_Atama______.L___250_KyHandanOrder;
using Grayscale.P511_KifuWarabe_.L___020_Kokoro;

namespace Grayscale.P511_KifuWarabe_.L020____Kokoro
{

    /// <summary>
    /// 頭の隅に置いてある、手の流れ。
    /// 
    /// 数局面にまたぐ、データです。
    /// </summary>
    public class TenonagareImpl : TenonagareGenjoImpl, Tenonagare
    {

        /// <summary>
        /// 妄想ログ。
        /// </summary>
        public ResultKioku ResultKioku { get; set; }



        /// <summary>
        /// 
        /// </summary>
        /// <param name="name"></param>
        /// <param name="save_node_OrNull"></param>
        /// <param name="owner"></param>
        public TenonagareImpl(
            RO_Kyokumen1 ro_Kyokumen1ForKioku_OrNull,
            KyHandanOrderName handanOrderName,
            TenonagareName name, RO_Star koma1, RO_Star koma2, Basho masu,
            KwErrorHandler errH
            )
            : base(handanOrderName, name, koma1, koma2, masu)
        {
            if (null != ro_Kyokumen1ForKioku_OrNull)
            {
                this.ResultKioku = new ResultKioku(ro_Kyokumen1ForKioku_OrNull.ToSfenstring(true));
            }
            else
            {
                this.ResultKioku = new ResultKioku(null);
            }

        }



        public Json_Val ToJsonVal()
        {
            Json_Obj obj = new Json_Obj();

            obj.Add(new Json_Prop("name", this.Name.ToString()));

            //TODO: obj.Add(new Json_Prop("finger", (int)this.Finger));//sprite

            obj.Add(new Json_Prop("masu", (int)this.Masu.MasuNumber));

            if (null != this.ResultKioku)
            {
                obj.Add(new Json_Prop("log", this.ResultKioku.ToJsonVal()));
            }

            return obj;
        }

    }
}
