﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P321_KyokumHyoka.L___250_Struct;
using Grayscale.P322_KifuTree___.L___250_Struct;
using Grayscale.P500_Kokoro_____.L___500_Kokoro;
using Grayscale.P505_Atama_Unou_.L250____Unou;
using Grayscale.P507_Atama______.L___500_KyHandan;
using Grayscale.P511_KifuWarabe_.L___020_Kokoro;
using System.Collections.Generic;

namespace Grayscale.P511_KifuWarabe_.L___040_KyHyoka
{

    /// <summary>
    /// 局面評価のエンジン。
    /// </summary>
    public interface KyHyokaCalculator
    {

        /// <summary>
        /// 局面スコアラーの一覧。
        /// </summary>
        Dictionary<TenonagareName, KyHandan> KyHyokas { get; }

        
        /// <summary>
        /// （１）ノードは、局面であるとともに、点数を覚えておくこともできます。
        /// （２）考え方の条件を指定します。
        /// （３）このメソッドは、「指定の駒が、指定のマスより、どれぐらい離れているか」で点数付けします。
        /// （４）ノードに、点数を設定します。
        /// </summary>
        KyHyokaMeisai_Koumoku LetHandan(
            Tenonagare atamanosumi,
            KifuNode node,
            PlayerInfo playerInfo,
            UnouImpl unou,
            KwErrorHandler errH
            );

    }
}
