﻿using Grayscale.P003_Log________.L___500_Struct;
using Grayscale.P238_Seiza______.L250____Struct;
using Grayscale.P324_ShogiGuiBas.L___500_Struct;
using Grayscale.P703_ShogiGui___.L___050_Shape;
using Grayscale.P703_ShogiGui___.L___100_Ui;
using Grayscale.P703_ShogiGui___.L___125_Scene;
using System.Collections.Generic;
using System.Windows.Forms;
using Finger = ProjectDark.NamedInt.StrictNamedInt0; //スプライト番号

namespace Grayscale.P703_ShogiGui___.L___500_Gui
{
    public interface ShogiGui : ShogiGui_Base
    {
        Timed TimedA { get; set; }
        Timed TimedB { get; set; }
        Timed TimedC { get; set; }
        void Timer_Tick();

        Response ResponseData { get; set; }

        /// <summary>
        /// 使い方：((Ui_Form1)this.OwnerForm)
        /// </summary>
        Form OwnerForm { get; set; }



        List<WidgetsLoader> WidgetLoaders { get; set; }

        /// <summary>
        /// ************************************************************************************************************************
        /// 手番が替わったときの挙動を、ここに書きます。
        /// ************************************************************************************************************************
        /// </summary>
        void ChangeTurn(KwErrorHandler errH);

        /// <summary>
        /// 将棋エンジンに、終了するように促します。
        /// </summary>
        void Shutdown();

        
        /// <summary>
        /// 将棋エンジンに、ログを出すように促します。
        /// </summary>
        void Logdase();

        
        /// <summary>
        /// ************************************************************************************************************************
        /// 将棋エンジンを起動します。
        /// ************************************************************************************************************************
        /// </summary>
        void Start(string shogiEngineFilePath);


        /// <summary>
        /// ------------------------------------------------------------------------------------------------------------------------
        /// グラフィックを描くツールは全部この中です。
        /// ------------------------------------------------------------------------------------------------------------------------
        /// </summary>
        Shape_PnlTaikyoku Shape_PnlTaikyoku { get; }


        /// <summary>
        /// ------------------------------------------------------------------------------------------------------------------------
        /// ゲームの流れの状態遷移図はこれです。
        /// ------------------------------------------------------------------------------------------------------------------------
        /// </summary>
        SceneName Scene { get; }
        void SetScene(SceneName scene);


        void Response(string mutexString, KwErrorHandler errH);



        string Input99 { get; set; }

        RO_Star GetKoma(Finger finger);

    }
}
